#!/bin/sh 

user=`whoami`
copyok=false
setupok=false
dosetup=true
batch=false
batchflag=""
self=`basename $0`
vers='2.4'
versfile="./.versinf"
iisusetup="iisuspagobi"
iiappname="Spago BI $vers"

usage()
{
    cat << EOF
usage:
	./install.sh [-nosetup]

EOF
}

gen_versinf()
{
    flist='./ingres/files/spagobi.rfm
./ingres/files/sp24.crs
./ingres/apps/spagobi24/context.xml
./ingres/apps/spagobi24/spagobi/jbpm_task.ingres
./ingres/apps/spagobi24/spagobi/sbi_obj_metadata.ingres
./ingres/apps/spagobi24/spagobi/jbpm_comment.ingres
./ingres/apps/spagobi24/spagobi/sbi_dist_list_objects.ingres
./ingres/apps/spagobi24/spagobi/sbi_remember_me.ingres
./ingres/apps/spagobi24/spagobi/sbi_viewpoints.ingres
./ingres/apps/spagobi24/spagobi/sbi_data_source.ingres
./ingres/apps/spagobi24/spagobi/sbi_kpi_model_attr_val.ingres
./ingres/apps/spagobi24/spagobi/jbpm_id_membership.ingres
./ingres/apps/spagobi24/spagobi/sbi_dossier_temp.ingres
./ingres/apps/spagobi24/spagobi/jbpm_taskcontroller.ingres
./ingres/apps/spagobi24/spagobi/sbi_parameters.ingres
./ingres/apps/spagobi24/spagobi/sbi_paruse.ingres
./ingres/apps/spagobi24/spagobi/sbi_threshold_value.ingres
./ingres/apps/spagobi24/spagobi/jbpm_swimlaneinstance.ingres
./ingres/apps/spagobi24/spagobi/sbi_threshold.ingres
./ingres/apps/spagobi24/spagobi/jbpm_variableaccess.ingres
./ingres/apps/spagobi24/spagobi/sbi_subreports.ingres
./ingres/apps/spagobi24/spagobi/sbi_snapshots.ingres
./ingres/apps/spagobi24/spagobi/jbpm_delegation.ingres
./ingres/apps/spagobi24/spagobi/jbpm_tokenvariablemap.ingres
./ingres/apps/spagobi24/spagobi/sbi_dossier_bin_temp.ingres
./ingres/apps/spagobi24/spagobi/sbi_lov.ingres
./ingres/apps/spagobi24/spagobi/sbi_kpi_inst_period.ingres
./ingres/apps/spagobi24/spagobi/jbpm_taskinstance.ingres
./ingres/apps/spagobi24/spagobi/copy.out
./ingres/apps/spagobi24/spagobi/schemaopt.sql
./ingres/apps/spagobi24/spagobi/sbi_obj_par.ingres
./ingres/apps/spagobi24/spagobi/sbi_kpi.ingres
./ingres/apps/spagobi24/spagobi/sbi_alarm_contact.ingres
./ingres/apps/spagobi24/spagobi/sbi_kpi_model_inst.ingres
./ingres/apps/spagobi24/spagobi/sbi_kpi_instance_history.ingres
./ingres/apps/spagobi24/spagobi/sbi_obj_state.ingres
./ingres/apps/spagobi24/spagobi/jbpm_runtimeaction.ingres
./ingres/apps/spagobi24/spagobi/sbi_kpi_model.ingres
./ingres/apps/spagobi24/spagobi/sbi_geo_map_features.ingres
./ingres/apps/spagobi24/spagobi/sbi_dossier_pres.ingres
./ingres/apps/spagobi24/spagobi/jbpm_transition.ingres
./ingres/apps/spagobi24/spagobi/sbi_paruse_det.ingres
./ingres/apps/spagobi24/spagobi/sbi_functions.ingres
./ingres/apps/spagobi24/spagobi/sbi_events_roles.ingres
./ingres/apps/spagobi24/spagobi/sbi_kpi_value.ingres
./ingres/apps/spagobi24/spagobi/jbpm_swimlane.ingres
./ingres/apps/spagobi24/spagobi/sbi_subobjects.ingres
./ingres/apps/spagobi24/spagobi/sbi_kpi_model_resources.ingres
./ingres/apps/spagobi24/spagobi/jbpm_moduledefinition.ingres
./ingres/apps/spagobi24/spagobi/sbi_obj_func.ingres
./ingres/apps/spagobi24/spagobi/jbpm_node.ingres
./ingres/apps/spagobi24/spagobi/sbi_measure_unit.ingres
./ingres/apps/spagobi24/spagobi/sbi_role_type_user_func.ingres
./ingres/apps/spagobi24/spagobi/jbpm_variableinstance.ingres
./ingres/apps/spagobi24/spagobi/sbi_obj_paruse.ingres
./ingres/apps/spagobi24/spagobi/sbi_exporters.ingres
./ingres/apps/spagobi24/spagobi/jbpm_bytearray.ingres
./ingres/apps/spagobi24/spagobi/sbi_engines.ingres
./ingres/apps/spagobi24/spagobi/sbi_dist_list.ingres
./ingres/apps/spagobi24/spagobi/sbi_paruse_ck.ingres
./ingres/apps/spagobi24/spagobi/sbi_alarm.ingres
./ingres/apps/spagobi24/spagobi/copy.in
./ingres/apps/spagobi24/spagobi/jbpm_message.ingres
./ingres/apps/spagobi24/spagobi/sbi_menu.ingres
./ingres/apps/spagobi24/spagobi/jbpm_exceptionhandler.ingres
./ingres/apps/spagobi24/spagobi/sbi_binary_contents.ingres
./ingres/apps/spagobi24/spagobi/sbi_func_role.ingres
./ingres/apps/spagobi24/spagobi/jbpm_taskactorpool.ingres
./ingres/apps/spagobi24/spagobi/sbi_kpi_role.ingres
./ingres/apps/spagobi24/spagobi/sbi_obj_metacontents.ingres
./ingres/apps/spagobi24/spagobi/sbi_object_notes.ingres
./ingres/apps/spagobi24/spagobi/jbpm_event.ingres
./ingres/apps/spagobi24/spagobi/sbi_audit.ingres
./ingres/apps/spagobi24/spagobi/sbi_kpi_model_attr.ingres
./ingres/apps/spagobi24/spagobi/sbi_user_func.ingres
./ingres/apps/spagobi24/spagobi/sbi_kpi_periodicity.ingres
./ingres/apps/spagobi24/spagobi/jbpm_id_group.ingres
./ingres/apps/spagobi24/spagobi/sbi_checks.ingres
./ingres/apps/spagobi24/spagobi/sbi_kpi_instance.ingres
./ingres/apps/spagobi24/spagobi/sbi_alarm_event.ingres
./ingres/apps/spagobi24/spagobi/sbi_alarm_distribution.ingres
./ingres/apps/spagobi24/spagobi/sbi_geo_maps.ingres
./ingres/apps/spagobi24/spagobi/sbi_menu_role.ingres
./ingres/apps/spagobi24/spagobi/jbpm_id_user.ingres
./ingres/apps/spagobi24/spagobi/sbi_events.ingres
./ingres/apps/spagobi24/spagobi/jbpm_moduleinstance.ingres
./ingres/apps/spagobi24/spagobi/sbi_dist_list_user.ingres
./ingres/apps/spagobi24/spagobi/sbi_domains.ingres
./ingres/apps/spagobi24/spagobi/sbi_geo_features.ingres
./ingres/apps/spagobi24/spagobi/sbi_resources.ingres
./ingres/apps/spagobi24/spagobi/jbpm_log.ingres
./ingres/apps/spagobi24/spagobi/sbi_events_log.ingres
./ingres/apps/spagobi24/spagobi/jbpm_decisionconditions.ingres
./ingres/apps/spagobi24/spagobi/jbpm_processdefinition.ingres
./ingres/apps/spagobi24/spagobi/sbi_ext_roles.ingres
./ingres/apps/spagobi24/spagobi/jbpm_processinstance.ingres
./ingres/apps/spagobi24/spagobi/jbpm_id_permissions.ingres
./ingres/apps/spagobi24/spagobi/jbpm_pooledactor.ingres
./ingres/apps/spagobi24/spagobi/jbpm_token.ingres
./ingres/apps/spagobi24/spagobi/sbi_objects_rating.ingres
./ingres/apps/spagobi24/spagobi/jbpm_action.ingres
./ingres/apps/spagobi24/spagobi/sbi_data_set.ingres
./ingres/apps/spagobi24/spagobi/sbi_object_templates.ingres
./ingres/apps/spagobi24/spagobi/jbpm_byteblock.ingres
./ingres/apps/spagobi24/spagobi/sbi_objects.ingres
./ingres/apps/spagobi24/spagobi/jbpm_timer.ingres
./ingres/apps/spagobi24/foodmart/account.ingres
./ingres/apps/spagobi24/foodmart/category.ingres
./ingres/apps/spagobi24/foodmart/department.ingres
./ingres/apps/spagobi24/foodmart/time_by_day.ingres
./ingres/apps/spagobi24/foodmart/warehouse.ingres
./ingres/apps/spagobi24/foodmart/store_ragged.ingres
./ingres/apps/spagobi24/foodmart/inventory_fact_1998.ingres
./ingres/apps/spagobi24/foodmart/store.ingres
./ingres/apps/spagobi24/foodmart/copy.out
./ingres/apps/spagobi24/foodmart/sales_fact_1998.ingres
./ingres/apps/spagobi24/foodmart/salary.ingres
./ingres/apps/spagobi24/foodmart/schemaopt.sql
./ingres/apps/spagobi24/foodmart/position.ingres
./ingres/apps/spagobi24/foodmart/promotion.ingres
./ingres/apps/spagobi24/foodmart/employee.ingres
./ingres/apps/spagobi24/foodmart/reserve_employee.ingres
./ingres/apps/spagobi24/foodmart/copy.in
./ingres/apps/spagobi24/foodmart/days.ingres
./ingres/apps/spagobi24/foodmart/warehouse_class.ingres
./ingres/apps/spagobi24/foodmart/region.ingres
./ingres/apps/spagobi24/foodmart/currency.ingres
./ingres/apps/spagobi24/foodmart/product.ingres
./ingres/apps/spagobi24/foodmart/sales_region.ingres
./ingres/apps/spagobi24/foodmart/customer.ingres
./ingres/apps/spagobi24/foodmart/product_class.ingres
./ingres/utility/iisuspagobi
./install.sh
'
    [ -f "$versfile" ] &&
    {
	cat << !
ERROR: Version file already exists, remove $versfile and try again

!
	exit -1
    }
    echo "Generating version info..."
    echo "#VERSION:$vers" > ${versfile}
    for f in $flist
    do
	md5sum $f >> ${versfile} ||
        {
	    rm -f ${versfile}
	    return 1
	}
    done
    cat ${versfile}
    echo "Sucessfully written to ${versfile}"
    

    return 0
}

check_versinf()
{
    local outfile=/tmp/vchk$$.out
    
    echo "Validating contents..."
    # verify file checksums against .versinf
    [ -r "${versfile}" ] ||
    {
	echo "Cannot locate version file"
	echo
        return 1
    }

    # check version
    confvers=`grep ^#VERSION ${versfile} | cut -d: -f2`
    [ "$confvers" != "${vers}" ] &&
    {
	echo "Version info mismatch"
	echo
	return 1
    }

    # check contents
    md5sum  -c "$versfile" > ${outfile} 2>&1 ||
    {
	cat $outfile
	echo
	rm -f $outfile > $outfile 2>&1
	return 1
    }
    rm -f $outfile > $outfile 2>&1
    return 0
}
# 
# Check params
#
while [ $1 ]
do
    case "$1" in
	-nosetup)
	    dosetup=false
	    shift
	    ;;
	-batch)
	    batchflag=-batch
	    batch=true
	    shift
	    ;;
	-genversinf)
	    [ $# -gt 1 ] && exit 1
	    gen_versinf
	    exit $?
	    ;;
	*)
	    usage
	    exit 1
	    ;;
    esac
done

#
# Startup message
#
echo "Installing schema and config for $iiappname"
echo
#
# Do a basic sanity check (II_SYSTEM set to a directory).
#
[ -z $II_SYSTEM ] || [ ! -d "$II_SYSTEM/ingres/" ] &&
{
    cat << !
II_SYSTEM must be set to the Ingres root directory before running $self.

Please correct your environment before running $self again.

!
    exit 1
}

if [ ! -r "./$self" ]
then
    cat << !
$self must be run from the directory in which it is located.

Please re-run $self from the root of the save set.

!
    exit 1
fi

#
# Check we can write to the installation directories
#
instowner=`ls -dl $II_SYSTEM/ingres/bin | cut -d' ' -f3`
if [ ! -O $II_SYSTEM/ingres/bin ]
then
    cat << !
II_SYSTEM/ingres is not owned by user "$user". 

Re-run the script as user "$instowner"
!
    exit 2
fi

#
# Validate the archive
#
check_versinf ||
{
    cat << !
Failed to validate contents of saveset, please check and try again.

!
    exit 3
}
#
# Setup environment
#
PATH=$II_SYSTEM/ingres/bin:$II_SYSTEM/ingres/utility:$PATH
LD_LIBRARY_PATH=$II_SYSTEM/ingres/lib
export PATH LD_LIBRARY_PATH

echo "Copying files..."
for d in files apps utility
do
    copyok=false
    [ -d ./ingres/$d ] ||
    {
	echo "Cannot locate directory ./ingres/$d, aborting..."
	break
    }
    cp -r ./ingres/$d $II_SYSTEM/ingres ||
    {
	echo "Failed to copy ingres/$d to $II_SYSTEM/ingres, aborting..."
	break
    }
    copyok=true
done

if $copyok && $dosetup
then
    echo "Running setup..."
    $batch && echo See \$II_SYSTEM/ingres/files/install.log for details
    chmod 755 $II_SYSTEM/ingres/utility/$iisusetup
    if [ ! -x $II_SYSTEM/ingres/utility/$iisusetup ]
    then
	cat << EOF
ERROR:
Setup script:

	$II_SYSTEM/ingres/utility/$iisusetup

does not exist or is not executable

EOF
    else
        (exec $II_SYSTEM/ingres/utility/$iisusetup $batchflag) && setupok=true
    fi
fi

echo
if $dosetup && ( ! $setupok || ! $copyok )
then
    echo "Setup failed"
    exit 4
else
    echo "Installation completed successfully"
    exit 0
fi
